unit NativeMethods;

interface

type

  PInteger = ^Integer;
  PPointer = ^Pointer;

  FTWRITEDATACALLBACK = procedure(lpParam: Pointer; const lpData: Pointer; nLen: Integer); stdcall;

  { FTVIDEOINFO structure }
  LPFTVIDEOINFO = ^FTVIDEOINFO;
  FTVIDEOINFO = record
    dwCodec: Integer;
    dwWidth: Integer;
    dwHeight: Integer;
  end;

  { FTAUDIOINFO structure }
  LPFTAUDIOINFO = ^FTAUDIOINFO;
  FTAUDIOINFO = record
    dwFormat: Integer;
    dwRate: Integer;
    dwSize: Integer;
    dwType: Integer;
  end;

  { FTFLVSTREAMINFO structure }
  LPFTFLVSTREAMINFO = ^FTFLVSTREAMINFO;
  FTFLVSTREAMINFO = record
    lpVideoInfo: LPFTVIDEOINFO;
    lpAudioInfo: LPFTAUDIOINFO;
    lpWriteDataCallback: FTWRITEDATACALLBACK;
    lpParam: Pointer;
  end;

  { Video Codec Enumeration }

  const FT_VIDEOCODEC_SCREENVIDEO: Integer = 03;

  { Audio Codec Enumeration }

  const FT_SOUNDFORMAT_UNCOMPRESSED: Integer = 00;

  const FT_SOUNDRATE_5KHZ: Integer = 00;
  const FT_SOUNDRATE_11KHZ: Integer = 01;
  const FT_SOUNDRATE_22KHZ: Integer = 02;
  const FT_SOUNDRATE_44KHZ: Integer = 03;

  const FT_SOUNDSIZE_8BIT: Integer = 00;
  const FT_SOUNDSIZE_16BIT: Integer = 01;

  const FT_SOUNDTYPE_MONO: Integer = 00;
  const FT_SOUNDTYPE_STEREO: Integer = 01;

  { FLV Stream interface }

  // Create FLV stream
  function ftFlvStreamCreate(const lpFlvStreamInfo: LPFTFLVSTREAMINFO): Integer; cdecl;
  external 'flashtool.dll' name 'ftFlvStreamCreate';
  // Destroy FLV stream
  procedure ftFlvStreamDestroy(hFlvStream: Integer); cdecl;
  external 'flashtool.dll' name 'ftFlvStreamDestroy';
  // Add video tag to FLV stream
  procedure ftFlvStreamPutVideoData(hFlvStream: Integer; const lpData: Pointer; nLen: Integer; nTimeStamp: Integer); cdecl;
  external 'flashtool.dll' name 'ftFlvStreamPutVideoData';
  // Add audio tag to FLV stream
  procedure ftFlvStreamPutAudioData(hFlvStream: Integer; const lpData: Pointer; nLen: Integer; nTimeStamp: Integer); cdecl;
  external 'flashtool.dll' name 'ftFlvStreamPutAudioData';
  // Set context secure key
  procedure ftSetContextKey(const szKey: PChar); cdecl;
  external 'flashtool.dll' name 'ftSetContextKey';

  { ScreenVideo encoder interface }

  // Create ScreenVideo encoder
  function ftScreenVideoEncoderCreate(dwWidth: Integer; dwHeight: Integer; dwBlockSize: Integer): Integer; cdecl;
  external 'flashtool.dll' name 'ftScreenVideoEncoderCreate';
  // Destroy ScreenVideo encoder
  procedure ftScreenVideoEncoderDestroy(hScreenVideoEncoder: Integer); cdecl;
  external 'flashtool.dll' name 'ftScreenVideoEncoderDestroy';
  // Encode row video frame to ScreenVideo frame
  function ftScreenVideoEncodeFrame(hScreenVideoEncoder: Integer; const lpData: Pointer; cbBytes: Integer; bFlipY: Boolean): Boolean; cdecl;
  external 'flashtool.dll' name 'ftScreenVideoEncodeFrame';
  // Get current encoded frame data
  procedure ftScreenVideoGetEncodedFrame(hScreenVideoEncoder: Integer; lppData: PPointer; lpcbBytes: PInteger); cdecl;
  external 'flashtool.dll' name 'ftScreenVideoGetEncodedFrame';

implementation

end.
